//	pro_sin.mq4 1.2	20120503

#property copyright	"pr0"
#property link			"thepr0.narod.ru"

#property indicator_chart_window
#property indicator_buffers	2
#property indicator_color1		DimGray		//  
#property indicator_color2		Yellow		//  

extern int		period=22;			//	 
extern int		window=4;			//	 ""  
extern int		amplitude=10;		//	  %  
extern int		shift=0;				//	 
extern string	objName="proObjCycles";		//	 

#define PI 3.1415926535

int 		tmp=0;	
double	buf1[], buf2[], buf3[];	//   

int init(){
	IndicatorBuffers(3);
	SetIndexBuffer(2, buf3);
	SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 1);
	SetIndexBuffer(0, buf1);
	SetIndexShift(0, shift);
	SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 1);
	SetIndexBuffer(1, buf2);
	SetIndexShift(1, shift);
	IndicatorShortName("pro_sin");
	setObjVLine();
	return(0);
}

int deinit(){	return(0);}

int start(){
	
	double	tmp1=WindowPriceMax()/WindowBarsPerChart();
	int		t0=getObjCoordinates(objName, OBJPROP_TIME1);	//	 
		
	if (t0>4 && tmp1!=tmp){
		tmp1=tmp;
		
		ArrayInitialize(buf1, EMPTY_VALUE);
		ArrayInitialize(buf2, EMPTY_VALUE);
		ArrayInitialize(buf3, period);
	
		int	Tsum=0, Isum=0, n=0;	//	  
				
		getT(period, window, t0);	//	 		
		while (drawSin(t0-Tsum, buf3[n])){	//	   	
			Tsum+=buf3[n];
			n++;
		}
		drawWindow(t0);		
		ObjectSetText(objName, "  "+period+"("+window+") ", 10, "Arial", Black);
	}	
	return(0);
}

int getObjCoordinates(string name, int n){
	if (ObjectFind(name)<0) return(-1);
	return(iBarShift(NULL, 0, ObjectGet(name, n)));
}

bool setObjVLine(){
	//	  OBJ_VLINE   objName
	int win=ObjectFind(objName);
	if (win<0){
		ObjectCreate(objName, OBJ_VLINE, 0, Time[50], 0, 0);
		ObjectSet(objName, OBJPROP_COLOR, RoyalBlue);
		ObjectSet(objName, OBJPROP_BACK, true);
		return(true);
	}
	return(false);
}

int getT(int T, int win, int startbar){
	//	   
	int cycles=0, n, idx;
	for (int i=startbar; i>=0; cycles++){
		n=i;
		i=i-T-win;
		if (i<0 || cycles>498)	break;
		idx=iLowest(NULL, 0, MODE_LOW, 2*win, i);
		buf3[cycles]=n-idx;	
		i=idx;
	}
	return(cycles);
}

bool drawSin(int startbar, int T){
	//	 sin,   startbar,  T	
	double	min=WindowPriceMin(), a=amplitude*(WindowPriceMax()-min)/100;	//		
	for(int i=0; i<=T; i++){
		if (startbar-i+shift<0)	return(false);
		buf1[startbar-i+shift]=a*MathAbs(MathSin(PI/T*i))+min;
	}
	return(true);
}

bool drawWindow(int startbar){
	//	 	 2*window
	int cy=0, tsum=0, t=startbar;
	
	for (int i=0; i>=-window; i--)
		buf2[i+t+shift]=buf1[i+t+shift];
		
	t=startbar-period;

	while (cy<499){
		for (i=window; i>=-window; i--){
			if (i+t+shift<0)	return(false);
			buf2[i+t+shift]=buf1[i+t+shift];
		}
		tsum+=buf3[cy];
		cy++;
		t=(startbar-tsum)-period;
	}
	return(true);
}